#include "gridinterpolator.hpp"
#include <iostream>
#include <fstream>
#include <myfitter/comparison.hpp>

typedef myfitter::grids::GridInterpolator1D<double, double> GridInterpolator1D;

inline bool differ(double a, double b)
{
    return myfitter::differ(a, b, 1.e-12, 1.e-12);
}

int main()
{
    std::cout.precision(15);

    GridInterpolator1D g1;
    if(!g1.read("spline.dat")) return 1;    

    if(differ(g1.spline_interp(0), 0)) return -1;
    if(differ(g1.spline_interp(0.0666666666666667), 0.388888888888889)) return -1;
    if(differ(g1.spline_interp(0.133333333333333), 0.722222222222222)) return -1;
    if(differ(g1.spline_interp(0.2), 1)) return -1;
    if(differ(g1.spline_interp(0.266666666666667), 1.23333333333333)) return -1;
    if(differ(g1.spline_interp(0.333333333333333), 1.41111111111111)) return -1;
    if(differ(g1.spline_interp(0.4), 1.5)) return -1;
    if(differ(g1.spline_interp(0.466666666666667), 1.47407407407407)) return -1;
    if(differ(g1.spline_interp(0.533333333333333), 1.35925925925926)) return -1;
    if(differ(g1.spline_interp(0.6), 1.2)) return -1;
    if(differ(g1.spline_interp(0.666666666666667), 0.988888888888889)) return -1;
    if(differ(g1.spline_interp(0.733333333333333), 0.733333333333334)) return -1;
    if(differ(g1.spline_interp(0.8), 0.5)) return -1;
    if(differ(g1.spline_interp(0.866666666666667), 0.311111111111111)) return -1;
    if(differ(g1.spline_interp(0.933333333333333), 0.144444444444445)) return -1;
    if(differ(g1.spline_interp(1), 0)) return -1;

    // for(int i=0; i<=15; ++i) {
    //     double x = i*1./15.;
    //     std::cout << "if(differ(g1.spline_interp(" << x << "), "
    //               << g1.spline_interp(x) << ")) return -1;" << std::endl;
    // }

    return 0;
}
